Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Protected Attributes | List of all members
Botan::XMSS_WOTS_Addressed_PrivateKey Class Referencefinal

`#include <xmss_wots_addressed_privatekey.h>`

Inheritance diagram for Botan::XMSS_WOTS_Addressed_PrivateKey:

## Public Member Functions
XMSS_Address & | address ()
const XMSS_Address & | address () const
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool strong) const override
virtual std::unique_ptr< PK_Ops::Decryption > | create_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Decryption > | create_kem_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Key_Agreement > | create_key_agreement_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Signature > | create_signature_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
virtual Signature_Format | default_x509_signature_format () const
size_t | estimated_strength () const override
std::string | fingerprint (const std::string &alg) const
std::string | fingerprint_private (const std::string &alg) const
std::string | fingerprint_public (const std::string &alg="SHA-256") const
OID | get_oid () const override
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
AlgorithmIdentifier | pkcs8_algorithm_identifier () const override
XMSS_WOTS_PrivateKey & | private_key ()
const XMSS_WOTS_PrivateKey & | private_key () const
secure_vector< uint8_t > | private_key_bits () const override
secure_vector< uint8_t > | private_key_info () const
XMSS_WOTS_PublicKey & | public_key ()
const XMSS_WOTS_PublicKey & | public_key () const
std::vector< uint8_t > | public_key_bits () const override
virtual bool | stateful_operation () const
std::vector< uint8_t > | subject_public_key () const
| XMSS_WOTS_Addressed_PrivateKey (const XMSS_WOTS_PrivateKey &private_key)
| XMSS_WOTS_Addressed_PrivateKey (const XMSS_WOTS_PrivateKey &private_key, const XMSS_Address &adrs)
| XMSS_WOTS_Addressed_PrivateKey (XMSS_WOTS_PrivateKey &&private_key)
| XMSS_WOTS_Addressed_PrivateKey (XMSS_WOTS_PrivateKey &&private_key, XMSS_Address &&adrs)

## Protected Attributes
XMSS_Address | m_adrs
XMSS_WOTS_PublicKey | m_pub_key

## Detailed Description

Wrapper class to pair an XMSS_WOTS_PrivateKey with an XMSS Address. Since the PK_Ops::Signature interface does not allow an extra address parameter to be passed to the sign(RandomNumberGenerator&), the address needs to be stored together with the key and passed to the XMSS_WOTS_Signature_Operation() on creation.

Definition at line 24 of file xmss_wots_addressed_privatekey.h.

## Constructor & Destructor Documentation

## ◆ XMSS_WOTS_Addressed_PrivateKey() [1/4]

Botan::XMSS_WOTS_Addressed_PrivateKey::XMSS_WOTS_Addressed_PrivateKey | ( | const XMSS_WOTS_PrivateKey & | private_key | ) |
| inline

Definition at line 29 of file xmss_wots_addressed_privatekey.h.

30 : XMSS_WOTS_Addressed_PublicKey(private_key),
31 m_priv_key(private_key) {}
Botan::XMSS_WOTS_Addressed_PrivateKey::private_key
const XMSS_WOTS_PrivateKey & private_key() const
Definition: xmss_wots_addressed_privatekey.h:48
Botan::XMSS_WOTS_Addressed_PublicKey::XMSS_WOTS_Addressed_PublicKey
XMSS_WOTS_Addressed_PublicKey(const XMSS_WOTS_PublicKey &public_key)
Definition: xmss_wots_addressed_publickey.h:27

## ◆ XMSS_WOTS_Addressed_PrivateKey() [2/4]

Botan::XMSS_WOTS_Addressed_PrivateKey::XMSS_WOTS_Addressed_PrivateKey | ( | const XMSS_WOTS_PrivateKey & | private_key,
|  | const XMSS_Address & | adrs
| ) |  |
| inline

Definition at line 33 of file xmss_wots_addressed_privatekey.h.

35 : XMSS_WOTS_Addressed_PublicKey(private_key, adrs),
36 m_priv_key(private_key) {}

## ◆ XMSS_WOTS_Addressed_PrivateKey() [3/4]

Botan::XMSS_WOTS_Addressed_PrivateKey::XMSS_WOTS_Addressed_PrivateKey | ( | XMSS_WOTS_PrivateKey && | private_key | ) |
| inline

Definition at line 38 of file xmss_wots_addressed_privatekey.h.

39 : XMSS_WOTS_Addressed_PublicKey(XMSS_WOTS_PublicKey(private_key)),
40 m_priv_key(std::move(private_key)) {}

## ◆ XMSS_WOTS_Addressed_PrivateKey() [4/4]

Botan::XMSS_WOTS_Addressed_PrivateKey::XMSS_WOTS_Addressed_PrivateKey | ( | XMSS_WOTS_PrivateKey && | private_key,
|  | XMSS_Address && | adrs
| ) |  |
| inline

Definition at line 42 of file xmss_wots_addressed_privatekey.h.

44 : XMSS_WOTS_Addressed_PublicKey(XMSS_WOTS_PublicKey(private_key),
45 std::move(adrs)),
46 m_priv_key(std::move(private_key)) {}

## Member Function Documentation

## ◆ address() [1/2]

XMSS_Address & Botan::XMSS_WOTS_Addressed_PublicKey::address | ( |  | ) |
| inline inherited

Definition at line 45 of file xmss_wots_addressed_publickey.h.

45{ return m_adrs; }
Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
XMSS_Address m_adrs
Definition: xmss_wots_addressed_publickey.h:91

References Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs.

## ◆ address() [2/2]

const XMSS_Address & Botan::XMSS_WOTS_Addressed_PublicKey::address | ( |  | ) | const
| inline inherited

Definition at line 44 of file xmss_wots_addressed_publickey.h.

44{ return m_adrs; }

References Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs.

## ◆ algo_name()

std::string Botan::XMSS_WOTS_Addressed_PublicKey::algo_name | ( |  | ) | const
| inline override virtual inherited

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 47 of file xmss_wots_addressed_publickey.h.

48 {
49 return m_pub_key.algo_name();
50 }
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:90
Botan::XMSS_WOTS_PublicKey::algo_name
std::string algo_name() const override
Definition: xmss_wots.h:336

References Botan::XMSS_WOTS_PublicKey::algo_name(), and Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key.

## ◆ algorithm_identifier()

AlgorithmIdentifier Botan::XMSS_WOTS_Addressed_PublicKey::algorithm_identifier | ( |  | ) | const
| inline override virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 52 of file xmss_wots_addressed_publickey.h.

53 {
54 return m_pub_key.algorithm_identifier();
55 }
Botan::XMSS_WOTS_PublicKey::algorithm_identifier
AlgorithmIdentifier algorithm_identifier() const override
Definition: xmss_wots.h:341

References Botan::XMSS_WOTS_PublicKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key.

## ◆ check_key()

bool Botan::XMSS_WOTS_Addressed_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| inline override virtual inherited

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Definition at line 57 of file xmss_wots_addressed_publickey.h.

58 {
59 return m_pub_key.check_key(rng, strong);
60 }
Botan::XMSS_WOTS_PublicKey::check_key
bool check_key(RandomNumberGenerator &, bool) const override
Definition: xmss_wots.h:346

References Botan::XMSS_WOTS_PublicKey::check_key(), and Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key.

## ◆ create_decryption_op()

std::unique_ptr< PK_Ops::Decryption > Botan::Private_Key::create_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ElGamal_PrivateKey, Botan::RSA_PrivateKey, and Botan::SM2_PrivateKey.

Definition at line 114 of file pk_keys.cpp.

117 {
118 throw Lookup_Error(algo_name() + " does not support decryption");
119 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Decryptor_EME::PK_Decryptor_EME().

## ◆ create_encryption_op()

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ElGamal_PublicKey, Botan::RSA_PublicKey, and Botan::SM2_PublicKey.

Definition at line 91 of file pk_keys.cpp.

94 {
95 throw Lookup_Error(algo_name() + " does not support encryption");
96 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

## ◆ create_kem_decryption_op()

std::unique_ptr< PK_Ops::KEM_Decryption > Botan::Private_Key::create_kem_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::McEliece_PrivateKey, and Botan::RSA_PrivateKey.

Definition at line 122 of file pk_keys.cpp.

125 {
126 throw Lookup_Error(algo_name() + " does not support KEM decryption");
127 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Decryptor::PK_KEM_Decryptor().

## ◆ create_kem_encryption_op()

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::McEliece_PublicKey, and Botan::RSA_PublicKey.

Definition at line 99 of file pk_keys.cpp.

102 {
103 throw Lookup_Error(algo_name() + " does not support KEM encryption");
104 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

## ◆ create_key_agreement_op()

std::unique_ptr< PK_Ops::Key_Agreement > Botan::Private_Key::create_key_agreement_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a key agreement operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::Curve25519_PrivateKey, Botan::DH_PrivateKey, and Botan::ECDH_PrivateKey.

Definition at line 138 of file pk_keys.cpp.

141 {
142 throw Lookup_Error(algo_name() + " does not support key agreement");
143 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Key_Agreement::PK_Key_Agreement().

## ◆ create_signature_op()

std::unique_ptr< PK_Ops::Signature > Botan::Private_Key::create_signature_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a signature operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_PrivateKey, Botan::TPM_PrivateKey, Botan::DSA_PrivateKey, Botan::ECDSA_PrivateKey, Botan::ECGDSA_PrivateKey, Botan::ECKCDSA_PrivateKey, Botan::Ed25519_PrivateKey, Botan::GOST_3410_PrivateKey, Botan::RSA_PrivateKey, and Botan::SM2_PrivateKey.

Definition at line 130 of file pk_keys.cpp.

133 {
134 throw Lookup_Error(algo_name() + " does not support signatures");
135 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Signer::PK_Signer().

## ◆ create_verification_op()

std::unique_ptr< PK_Ops::Verification > Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| inline override virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 63 of file xmss_wots_addressed_publickey.h.

65 {
66 return m_pub_key.create_verification_op(params, provider);
67 }
Botan::Public_Key::create_verification_op
virtual std::unique_ptr< PK_Ops::Verification > create_verification_op(const std::string &params, const std::string &provider) const
Definition: pk_keys.cpp:107

References Botan::Public_Key::create_verification_op(), and Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key.

## ◆ default_x509_signature_format()

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 125 of file pk_keys.h.

126 {
127 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
128 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:112
Botan::DER_SEQUENCE
@ DER_SEQUENCE
Definition: pk_keys.h:23
Botan::IEEE_1363
@ IEEE_1363
Definition: pk_keys.h:23

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

## ◆ estimated_strength()

size_t Botan::XMSS_WOTS_Addressed_PublicKey::estimated_strength | ( |  | ) | const
| inline override virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 74 of file xmss_wots_addressed_publickey.h.

75 {
76 return m_pub_key.estimated_strength();
77 }
Botan::XMSS_WOTS_PublicKey::estimated_strength
size_t estimated_strength() const override
Definition: xmss_wots.h:351

References Botan::XMSS_WOTS_PublicKey::estimated_strength(), and Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key.

## ◆ fingerprint()

std::string Botan::Private_Key::fingerprint | ( | const std::string & | alg | ) | const
| inline inherited

Definition at line 215 of file pk_keys.h.

216 {
217 return fingerprint_private(alg); // match behavior in previous versions
218 }
Botan::Private_Key::fingerprint_private
std::string fingerprint_private(const std::string &alg) const
Definition: pk_keys.cpp:85

## ◆ fingerprint_private()

std::string Botan::Private_Key::fingerprint_private | ( | const std::string & | alg | ) | const
| inherited

Returns
  Hash of the PKCS #8 encoding for this key object

Definition at line 85 of file pk_keys.cpp.

86 {
87 return create_hex_fingerprint(private_key_bits(), hash_algo);
88 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Private_Key::private_key_bits().

Referenced by Botan::Certificate_Store_In_SQL::find_certs_for_key(), Botan::Certificate_Store_In_SQL::insert_key(), and Botan::Certificate_Store_In_SQL::remove_key().

## ◆ fingerprint_public()

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Public_Key::subject_public_key().

## ◆ get_oid()

OID Botan::XMSS_WOTS_Addressed_PublicKey::get_oid | ( |  | ) | const
| inline override virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented from Botan::Public_Key.

Definition at line 69 of file xmss_wots_addressed_publickey.h.

70 {
71 return m_pub_key.get_oid();
72 }
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53

References Botan::Public_Key::get_oid(), and Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key.

## ◆ key_length()

size_t Botan::XMSS_WOTS_Addressed_PublicKey::key_length | ( |  | ) | const
| inline override virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 79 of file xmss_wots_addressed_publickey.h.

80 {
81 return m_pub_key.estimated_strength();
82 }

References Botan::XMSS_WOTS_PublicKey::estimated_strength(), and Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key.

## ◆ message_part_size()

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 123 of file pk_keys.h.

123{ return 0; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ message_parts()

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 112 of file pk_keys.h.

112{ return 1; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ pkcs8_algorithm_identifier()

AlgorithmIdentifier Botan::XMSS_WOTS_Addressed_PrivateKey::pkcs8_algorithm_identifier | ( |  | ) | const
| inline override virtual

Returns
  PKCS #8 AlgorithmIdentifier for this key Might be different from the X.509 identifier, but normally is not

Reimplemented from Botan::Private_Key.

Definition at line 52 of file xmss_wots_addressed_privatekey.h.

53 {
54 return m_priv_key.pkcs8_algorithm_identifier();
55 }
Botan::XMSS_WOTS_PrivateKey::pkcs8_algorithm_identifier
AlgorithmIdentifier pkcs8_algorithm_identifier() const override
Definition: xmss_wots.h:714

References Botan::XMSS_WOTS_PrivateKey::pkcs8_algorithm_identifier().

## ◆ private_key() [1/2]

XMSS_WOTS_PrivateKey & Botan::XMSS_WOTS_Addressed_PrivateKey::private_key | ( |  | ) |
| inline

Definition at line 49 of file xmss_wots_addressed_privatekey.h.

49{ return m_priv_key; }

## ◆ private_key() [2/2]

const XMSS_WOTS_PrivateKey & Botan::XMSS_WOTS_Addressed_PrivateKey::private_key | ( |  | ) | const
| inline

Definition at line 48 of file xmss_wots_addressed_privatekey.h.

48{ return m_priv_key; }

## ◆ private_key_bits()

secure_vector< uint8_t > Botan::XMSS_WOTS_Addressed_PrivateKey::private_key_bits | ( |  | ) | const
| inline override virtual

Returns
  BER encoded private key bits

Implements Botan::Private_Key.

Definition at line 57 of file xmss_wots_addressed_privatekey.h.

58 {
59 return m_priv_key.private_key_bits();
60 }
Botan::XMSS_WOTS_PrivateKey::private_key_bits
secure_vector< uint8_t > private_key_bits() const override
Definition: xmss_wots.h:719

References Botan::XMSS_WOTS_PrivateKey::private_key_bits().

## ◆ private_key_info()

secure_vector< uint8_t > Botan::Private_Key::private_key_info | ( |  | ) | const
| inherited

Returns
  PKCS #8 private key encoding for this key object

Definition at line 61 of file pk_keys.cpp.

62 {
63 const size_t PKCS8_VERSION = 0;
64
65 return DER_Encoder()
66 .start_cons(SEQUENCE)
67 .encode(PKCS8_VERSION)
68 .encode(pkcs8_algorithm_identifier())
69 .encode(private_key_bits(), OCTET_STRING)
70 .end_cons()
71 .get_contents();
72 }
Botan::Private_Key::pkcs8_algorithm_identifier
virtual AlgorithmIdentifier pkcs8_algorithm_identifier() const
Definition: pk_keys.h:204
Botan::SEQUENCE
@ SEQUENCE
Definition: asn1_obj.h:42
Botan::OCTET_STRING
@ OCTET_STRING
Definition: asn1_obj.h:38

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::OCTET_STRING, Botan::Private_Key::pkcs8_algorithm_identifier(), Botan::Private_Key::private_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::PKCS8::BER_encode(), Botan::PKCS8::BER_encode_encrypted_pbkdf_iter(), and Botan::PKCS8::BER_encode_encrypted_pbkdf_msec().

## ◆ public_key() [1/2]

XMSS_WOTS_PublicKey & Botan::XMSS_WOTS_Addressed_PublicKey::public_key | ( |  | ) |
| inline inherited

Definition at line 42 of file xmss_wots_addressed_publickey.h.

42{ return m_pub_key; }

References Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key.

## ◆ public_key() [2/2]

const XMSS_WOTS_PublicKey & Botan::XMSS_WOTS_Addressed_PublicKey::public_key | ( |  | ) | const
| inline inherited

Definition at line 41 of file xmss_wots_addressed_publickey.h.

41{ return m_pub_key; }

References Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key.

## ◆ public_key_bits()

std::vector< uint8_t > Botan::XMSS_WOTS_Addressed_PublicKey::public_key_bits | ( |  | ) | const
| inline override virtual inherited

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 84 of file xmss_wots_addressed_publickey.h.

85 {
86 return m_pub_key.public_key_bits();
87 }
Botan::XMSS_WOTS_PublicKey::public_key_bits
std::vector< uint8_t > public_key_bits() const override
Definition: xmss_wots.h:361

References Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key, and Botan::XMSS_WOTS_PublicKey::public_key_bits().

## ◆ stateful_operation()

virtual bool Botan::Private_Key::stateful_operation | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::XMSS_PrivateKey.

Definition at line 188 of file pk_keys.h.

188{ return false; }

## ◆ subject_public_key()

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::BIT_STRING
@ BIT_STRING
Definition: asn1_obj.h:37

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

## Member Data Documentation

## ◆ m_adrs

XMSS_Address Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
| protected inherited

Definition at line 91 of file xmss_wots_addressed_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::address().

## ◆ m_pub_key

XMSS_WOTS_PublicKey Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
| protected inherited

Definition at line 90 of file xmss_wots_addressed_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::algo_name(), Botan::XMSS_WOTS_Addressed_PublicKey::algorithm_identifier(), Botan::XMSS_WOTS_Addressed_PublicKey::check_key(), Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op(), Botan::XMSS_WOTS_Addressed_PublicKey::estimated_strength(), Botan::XMSS_WOTS_Addressed_PublicKey::get_oid(), Botan::XMSS_WOTS_Addressed_PublicKey::key_length(), Botan::XMSS_WOTS_Addressed_PublicKey::public_key(), and Botan::XMSS_WOTS_Addressed_PublicKey::public_key_bits().

The documentation for this class was generated from the following file:

- src/lib/pubkey/xmss/xmss_wots_addressed_privatekey.h